;
;    .
;        
;
;           push       <str>              ; 
;           push       <num>              ; 
;           push       2                  ;  
;           push       28C8h
;           create_object
;           call       TMENU_DBG.Create
;           pop
;
;    OutTxt
;
;    push     <str>           ;  - 
;    push     <val>           ; 
;    push     2               ;  
;    call58   global.OutText
;    pop
;
;
           .section   code, con

.classdef  TMENU_DBG(TMENU_ID), 28C8h
; variables
  .vint      dbg_CurValue
  .vstr      dbg_CurString
; procedures
  .func      Create
  .func      GetName
  .func      GetObjectBody
  .func      SpecialMenu
  .func      SpecialUpdate
  .func      GetClass
  .func      IsClass
  .func      ExitMenu
.endclass  TMENU_DBG

;      push       SP[4]              ; 
;      push       SP[4]              ; 
;      push       2                  ;  
;      push       28C8h
;      create_object
;      call       TMENU_DBG.Create
TMENU_DBG.Create:
           setmem     3
           push       SP[4]                     ;
           write      TMENU_DBG.dbg_CurString   ;
           pop

           push       SP[3]                     ;
           write      TMENU_DBG.dbg_CurValue    ;
           pop

           push       0
           push       1
           push       08A2h
           call       TMENU_ID.Create ; 0000101B
           ret

TMENU_DBG.GetName:
           setmem     1 ; 1
           get_strg   dbg_title ; "Mini debug"
           ret

TMENU_DBG.GetObjectBody:
           setmem     1
           push       0BEh ; 190d
           ret

TMENU_DBG.GetClass:
           setmem     1
           push       28C8h ; 2248d
           ret

TMENU_DBG.IsClass:
           setmem     3
           push       SP[3]
           push       28C8h ;
           if SP[0]<>SP[1] then push 0 else push 1
           if SP[0]<>0 then jump $01
           push       SP[3]
           push       1 ; 1
           push       08A2h ; 2210d
           call       TMENU_ID.IsClass ; 00000FB5
           ret

$01:       push       1
           ret

TMENU_DBG.SpecialMenu:
           setmem     2 ; 2
           push       0 ; 0
           write      TMENU.me_FirstLineInfo ; [0Bh ; 11d]
           pop
           push       8 ; 8
           write      TMENU.me_PageLinesInfo ; [0Dh ; 13d]
           pop
           push       2 ; 2
           write      TMENU.me_TopLineInfo ; [0Eh ; 14d]
           pop
           push       0 ; 0
           push       08A2h ; 2210d
           call       TMENU_ID.SpecialMenu ; 00007A6B
           pop
           push       0 ; 0
           ret

TMENU_DBG.SpecialUpdate:
           setmem     03h
           push       0
           get_object
           call       TMENU.StartInfo   ;
           pop
           
           get_strg   dbg_subtt         ; "Output value of variable"
           push       1
           get_object
           call       TMENU.AddInfoLine ;
           pop

           read       TMENU_DBG.dbg_CurString
           push       1
           get_object
           call       TMENU.AddInfoLine ;
           pop

           read       TMENU_DBG.dbg_CurValue
           get_strg   dbg_fmt           ; "Variable = %d "
           push       2
           callasm    SE_SPrintf
           push       1
           get_object
           call       TMENU.AddInfoLine ;
           pop
           
           push       0
           get_object
           call       TMENU.EndInfo     ;
           pop
           push       0
           ret

TMENU_DBG.ExitMenu:
           setmem     3
           read       TMENU.me_Object ;
           if SP[0]=0 then jump L000DD99A
           read       TMENU.me_Object ;
           push       1
           callasm    SE_ObjectExists ;
           if SP[0]=0 then jump L000DD99A
           push       1
           jump       L000DD99C

L000DD99A: push       0 ;
L000DD99C: if SP[0]=0 then jump L000DD9B2
           push       0 ;
           push       1 ;
           read       TMENU.me_Object
           call       SetUpdateFocus
           pop
L000DD9B2: push       0 ;
           push       08A2h ;
           call       TMENU.ExitMenu ;
           pop
           push       0 ; 0
           ret

;
; Global support routine
;
;    
; 
;    push     <str>           ;  - 
;    push     <val>           ; 
;    push     2               ;  
;    call58   global.OutText
;    pop
;
.func      OutText
OutText:   setmem     4d

           push       SP[4]              ; 
           push       SP[4]              ; 
           push       2                  ;  
           push       28C8h
           create_object
           call       TMENU_DBG.Create
           ret

           .section   strg, con

dbg_title: .ascii     "Mini debug"
dbg_subtt: .ascii     "Output value of variable"
dbg_fmt:   .ascii     "Variable = %04d"

